#include "stdafx.h"
#include "DrvFunc.h"
#include "stdio.h"


//DrvFunc.cpp
//Driver Functions
/*-------------------------------------------------------------------
SimpleDrvStart
-------------------------------------------------------------------*/
HANDLE MakeDrvSimpleStart(PCHAR pPath, PCHAR pName)
{
	DWORD dwError = ERROR_SUCCESS;
	char  szPathName[256];
	HANDLE hHandle;

	//1. Register Driver
	//Default, pPathName = Current Directory + pName + .sys
	if(pPath == NULL)
	{
		//
		char *p;
		DWORD dwSize = (DWORD)GetModuleFileName( NULL, szPathName, 256 );
		if ( dwSize && dwSize <= 256 )
			p = strrchr ( szPathName , '\\' );
		if ( p ) 
			*(p + 1) = '\0';
		strcat(szPathName, pName);
		strcat(szPathName, ".sys");
	}
	else
	{
		strcpy(szPathName, pPath);
	}

	dwError = MakeDrvRegister(szPathName, pName);
	if(dwError && dwError != ERROR_SERVICE_EXISTS) return 0;	
	/* Test Result - 񽺰 ̹ ϵǾ  ص ǹ̰ .
	if(dwError == ERROR_SERVICE_EXISTS)
	{
		//Check and Modify the Driver Path 
		char szRegPath[256];
		char szRegKey[256];
		HKEY hKey;

		sprintf(szRegPath, "\\??\\%s", szPathName);
		sprintf(szRegKey, "SYSTEM\\CurrentControlSet\\Services\\%s", pName);
		
		dwError = RegOpenKeyEx(	HKEY_LOCAL_MACHINE,	szRegKey, 0, KEY_ALL_ACCESS, &hKey);
		if(dwError == 0)
		{
			dwError = RegSetValueEx(hKey, "ImagePath", 0, REG_EXPAND_SZ, (BYTE *)szRegPath, sizeof(szRegPath) + 1);
			RegCloseKey(hKey);
		}

	}
	*/

	//2. Start Driver.
	hHandle = MakeDrvStart(pName);

	return hHandle;
}

/*-------------------------------------------------------------------
Register Device Driver
-------------------------------------------------------------------*/
DWORD MakeDrvRegister(PCHAR pPath, PCHAR pName)
{
	DWORD dwError = ERROR_SUCCESS;
	SC_HANDLE hSCMan = NULL;
	SC_HANDLE hService = NULL;

	// connect to local service control manager
	if ((hSCMan = OpenSCManager(NULL, NULL, SC_MANAGER_CREATE_SERVICE )) == NULL) 
	{
		dwError = GetLastError();
		return dwError;
	}

	// add to service control manager's database
	if ((hService = CreateService(hSCMan, pName, pName, GENERIC_READ, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, 
								SERVICE_ERROR_NORMAL, pPath, NULL, NULL, NULL, NULL, NULL)) == NULL)
   	{
         dwError = GetLastError();
    }
  	else
  	{ 
  		CloseServiceHandle(hService);
  	}

	CloseServiceHandle(hSCMan);
  	
	return dwError;
}

/*-------------------------------------------------------------------
UnRegister Device Driver
-------------------------------------------------------------------*/
DWORD MakeDrvUnRegister(PCHAR pName)
{
	DWORD dwError = ERROR_SUCCESS;
	SC_HANDLE hSCMan = NULL;
	SC_HANDLE hService = NULL;
	
	// connect to local service control manager
	if ((hSCMan = OpenSCManager(NULL, NULL, SC_MANAGER_CONNECT)) == NULL)
	{
		dwError = GetLastError();
		return dwError;
	}

	// get a handle to the service
	if ((hService = OpenService(hSCMan, pName, DELETE)) != NULL)
	{
		// remove the driver
		if (!DeleteService(hService))
		{
			dwError = GetLastError();
		}		 
		CloseServiceHandle(hService);
	}
	else 
	{
		dwError = GetLastError();
	}
	CloseServiceHandle(hSCMan);
  	
	return dwError;
}

/*-------------------------------------------------------------------
Start Device Driver
-------------------------------------------------------------------*/
HANDLE MakeDrvStart(LPSTR lpDriver)
{
	DWORD dwError = ERROR_SUCCESS;
	SC_HANDLE hSCMan = NULL;
	SC_HANDLE hService = NULL;
	char	szDrvName[50];	
	HANDLE	h = 0;
	BOOL	bOpened = FALSE;

	// connect to local service control manager
	if ((hSCMan = OpenSCManager(NULL, NULL, SC_MANAGER_CONNECT)) == NULL) 
	{
		dwError = GetLastError();
		OutputDebugString("MakeDrvStart - OpenSCManger Error\n");
		return 0;
	}

	// get a handle to the service
	if ((hService = OpenService(hSCMan, lpDriver, SERVICE_START)) != NULL) 
	{
		bOpened = TRUE;
		// start the driver
		if (!StartService(hService, 0, NULL))
		{
			OutputDebugString("MakeDrvStart - Service Start Error\n");
			dwError = GetLastError();
		}

  		CloseServiceHandle(hService);
	} 
	else 
	{
		char szMsg[50];

		dwError = GetLastError();
		sprintf(szMsg, "MakeDrvStart - Service Open Error(%d)\n", dwError);
		OutputDebugString(szMsg);		
	}
	
	CloseServiceHandle(hSCMan); 	

	//2. Get The Device Object Handle
	if(bOpened)
	{
		sprintf(szDrvName, "\\\\.\\%s", lpDriver);
		h = CreateFile (szDrvName, GENERIC_READ | GENERIC_WRITE, 0 , NULL , OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL , NULL );
		if (h == INVALID_HANDLE_VALUE)
		{
			char szTest[50];
			sprintf(szTest, "MakeDrvStart[CreateFile Error] : Err(%d, 0x%x)", GetLastError(), GetLastError());
			OutputDebugString(szTest);
			return 0;
		}
	}
	return h;
}

/*-------------------------------------------------------------------
Stop Device Driver
-------------------------------------------------------------------*/
DWORD MakeDrvStop(LPSTR lpDriver, HANDLE hHandle)
{
	DWORD dwError = ERROR_SUCCESS;
	SC_HANDLE hSCMan = NULL;
	SC_HANDLE hService = NULL;
	SERVICE_STATUS serviceStatus;
	
	if(hHandle)
		CloseHandle(hHandle);

	// connect to local service control manager
	if ((hSCMan = OpenSCManager(NULL, NULL, SC_MANAGER_CONNECT)) == NULL) 
	{
		dwError = GetLastError();
		return dwError;
	}

	// get a handle to the service
	if ((hService = OpenService(hSCMan, lpDriver, SERVICE_STOP)) != NULL) 
	{
		// stop the driver
		if (!ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus))
		{
		    dwError = GetLastError();
		}
		CloseServiceHandle(hService);
	} 
	else 
	{
		dwError = GetLastError();
	}
	
	CloseServiceHandle(hSCMan);
  	
	return dwError;
}

/*-------------------------------------------------------------------
Control Device Driver
-------------------------------------------------------------------*/
DWORD MakeDrvControl(LPSTR lpDriver, DWORD dwCode, PVOID pInputBuffer, DWORD dwInputBufferSize,
					PVOID pOutputBuffer, DWORD dwOutputBufferSize)
{
	DWORD dwError = ERROR_SUCCESS;
	DWORD dwReturned;
	HANDLE hDevice;
	CHAR szName[30];

	wsprintf(szName, "\\\\.\\%s", lpDriver);

	hDevice = CreateFile(szName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if (hDevice == INVALID_HANDLE_VALUE) 
	{
		dwError = GetLastError();
		return dwError;
	}

	if (!DeviceIoControl(hDevice, dwCode, pInputBuffer, dwInputBufferSize, 
						pOutputBuffer, dwOutputBufferSize, &dwReturned, NULL))
	{
		dwError = GetLastError();
	}

	CloseHandle(hDevice);

	return dwError;
}

/*-------------------------------------------------------------------
IoControl
-------------------------------------------------------------------*/
BOOL MakeDrvIoControl (HANDLE hDevice, DWORD dCode, PVOID  pInput, DWORD  dInput, PVOID  pOutput, DWORD  dOutput)
{
	DWORD dData = 0;
	BOOL bReturn;

	if(hDevice == NULL) return FALSE;

	if(pInput == NULL || dInput == 0)
	{
		pInput = (PVOID)&dData;
		bReturn = DeviceIoControl (hDevice, dCode, pInput,  sizeof(DWORD), pOutput, dOutput, &dData,  NULL) 
			&& (dData == dOutput);
	}
	else
	{
		bReturn = DeviceIoControl (hDevice, dCode, pInput,  dInput, pOutput, dOutput, &dData,  NULL) 
			&& (dData == dOutput);
	}
    return bReturn;
}
